;
;Simple PureBasic example for the LabJack UE9 using the UD driver for Windows.
;support@labjack.com
;Jul 31, 2006
;

    OpenConsole()
    ConsoleTitle ("LabJackUD PureBasic Example:")
    EnableGraphicalConsole(0)

    lngErrorcode.l
    lngHandle.l
    dblValue.d
    Prototype.d ProtoGetDriverVersion()
    Prototype.l ProtoOpenLabJack(DeviceType.l, ConnectionType.l, Address.s, FirstFound.l, *lngHandle.l)
    Prototype.l ProtoeGetS(pHandle.l, IOType.s, Channel.l, *dblValue.d, x1.l)
    Prototype.l ProtoeGetSS(pHandle.l, IOType.s, Channel.s, *dblValue.d, x1.l)
    ;The former is used with most basic IOTypes that operate on a particular
    ;channel, while the latter is generally used with the put_config/get_config
    ;types operating on the device as a whole.

    If OpenLibrary(0,"labjackud.dll")
    
      fGetDriverVersion.ProtoGetDriverVersion = GetFunction(0, "GetDriverVersion")
      fOpenLabJack.ProtoOpenLabJack = GetFunction(0, "OpenLabJack")
      feGetS.ProtoeGetS = GetFunction(0, "eGetS")
      feGetSS.ProtoeGetSS = GetFunction(0, "eGetSS")
      
      ;Get the UD driver version.
      driverVersion.d = fGetDriverVersion()
      PrintN("GetDriverVersion = "+StrD(driverVersion,2))
            
      ;Open the first found USB LabJack UE9.
      ;DeviceType:      U3=3 or UE9=9
      ;ConnectionType:  USB=1 or Ethernet=2
      lngErrorcode = fOpenLabJack( 9, 1, "1", 1, @lngHandle)
      PrintN("OpenLabJack errorcode = "+Str(lngErrorcode))
      
      ;Read the serial number of the LabJack.
      lngErrorcode = feGetSS( lngHandle, "LJ_ioGET_CONFIG", "LJ_chSERIAL_NUMBER", @dblValue, 0)
      PrintN("")
      PrintN("errorcode = "+Str(lngErrorcode))
      PrintN("Serial Number = "+StrD(dblValue,0))
      
      ;Get a reading from analog input 0 (AIN0).
      lngErrorcode = feGetS( lngHandle, "LJ_ioGET_AIN", 0, @dblValue, 0)
      PrintN("")
      PrintN("errorcode = "+Str(lngErrorcode))
      PrintN("AIN0 = "+StrD(dblValue,6))
      
      ;Get a reading from digital input 0 (FIO0).
      lngErrorcode = feGetS( lngHandle, "LJ_ioGET_DIGITAL_BIT", 0, @dblValue, 0)
      PrintN("")
      PrintN("errorcode = "+Str(lngErrorcode))
      PrintN("FIO0 = "+StrD(dblValue,0))
      
      ;Set analog output 0 (DAC0) to 2.5 volts.
      dblValue = 2.5
      lngErrorcode = feGetS( lngHandle, "LJ_ioPUT_DAC", 0, @dblValue, 0)
      PrintN("")
      PrintN("errorcode = "+Str(lngErrorcode))
      PrintN("DAC0 set to 2.5 volts")
      
      ;Set digital line 1 (FIO1) to output-low .
      dblValue = 0
      lngErrorcode = feGetS( lngHandle, "LJ_ioPUT_DIGITAL_BIT", 1, @dblValue, 0)
      PrintN("")
      PrintN("errorcode = "+Str(lngErrorcode))
      PrintN("FIO1 set to output-low")
      
      
    Else
      PrintN("Open Library Failed")
    EndIf

    PrintN("")
    Print ("Press <Enter> to exit:   ")
    name$=Input()

    CloseLibrary(0)
    CloseConsole()
End
; IDE Options = PureBasic v4.00 (Windows - x86) (Demo)
; CursorPosition = 7
; Folding = -